"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const generated_1 = require("./generated");
const node_fetch_1 = __importDefault(require("node-fetch"));
const DEFAULT_API_URL = "https://api.cloud.ravendb.net";
const http = { fetch: node_fetch_1.default };
__export(require("./generated"));
class ApiClient {
    constructor(opts) {
        opts = opts || {};
        if (!opts.apiKey) {
            throw new Error("Passing an apiKey is required. In order to obtain one please navigate to 'API Keys' in your RavenDB Cloud user portal.");
        }
        opts.url = (opts.url || DEFAULT_API_URL).replace(/\/$/, "");
        this._account = new generated_1.AccountClient(opts, opts.url, http);
        this._metadata = new generated_1.MetadataClient(opts, opts.url, http);
        this._products = new generated_1.ProductsClient(opts, opts.url, http);
    }
    get account() {
        return this._account;
    }
    ;
    get products() {
        return this._products;
    }
    get metadata() {
        return this._metadata;
    }
}
exports.ApiClient = ApiClient;
